varying vec4 vertexEye;

vec3 shipBaseColor = vec3(1.0, 0.8, 0.4);


vec3 calculateMaterial(vec3 L, vec3 Lcolor, vec3 N)
{
    float diffuse = 0.6;
    float specular = 3.0;
    float specularity = 30.0;

    float NdotL = max(dot(N, L), 0.0);

    float spec = 0.0;
    if (NdotL > 0.0) {
        vec3 R = 2.0 * NdotL * N - L;
        vec3 V = normalize(-vertexEye.xyz);
        spec = pow(max(dot(R, V), 0.0), specularity);
    }

    return shipBaseColor * Lcolor * (NdotL * diffuse + spec * specular);
}

vec3 calculateMaterialAmbient(vec3 Lcolor)
{
    return Lcolor * shipBaseColor;
}
