/*
 * Copyright 2008  Rivo Laks <rivolaks@hot.ee>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "asteroid.h"

#include "model.h"

#include <kgllib/kgllib.h>
#include <kgllib/mesh.h>

using namespace KGLLib;


Asteroid::Asteroid(float radius) : GameObject(radius)
{
    mModel = 0;
    mModelScale = radius;

    mCollVertexData = 0;
}

Asteroid::~Asteroid()
{
    delete[] mCollVertexData;
}

void Asteroid::setModel(Model* model)
{
    mModel = model;
    Batch* collisionmesh = model->collisionMesh();
    const Vector3f* originalVertices = reinterpret_cast<const Vector3f*>(collisionmesh->verticesArray());
    mCollVertexData = new Vector3f[collisionmesh->vertexCount()];
    for (unsigned int i = 0; i < collisionmesh->vertexCount(); i++) {
        mCollVertexData[i] = originalVertices[i] * radius;
    }
    createGeomFromMesh(mCollVertexData, collisionmesh->vertexCount(),
                        reinterpret_cast<const unsigned int*>(collisionmesh->indicesArray()), collisionmesh->indicesCount());
}
