/*
    Copyright 2009  Rivo Laks <rivolaks@hot.ee>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GAMEGUIVIEW_H
#define GAMEGUIVIEW_H

#include "glview.h"

class GameWorld;
class GLMeter;


class GameGUIView : public GLView
{
    Q_OBJECT
    public:
        GameGUIView(KGLLib::GLWidget* parent, GameWorld* world);

        virtual void init();
        virtual void resize(int w, int h);
        virtual void render();

    public slots:
        void setShowRenderInfo(bool show);

    private:
        GameWorld* mWorld;

        GLMeter* mThrustoMeter;
        GLMeter* mSpeedoMeter;

        bool mShowRenderInfo;
};

#endif // GAMEGUIVIEW_H
