/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "planet.h"

#include <kgllib/mesh.h>

using namespace KGLLib;
using namespace Eigen;


Planet::Planet(Mesh* model)
{
    mModel = model;
}

void Planet::setPosition(const Vector3f& pos)
{
    mPosition = pos;
}

void Planet::render()
{
    glPushMatrix();

    glTranslatef(mPosition.x(), mPosition.y(), mPosition.z());
    glScalef(mRadius, mRadius, mRadius);
    mModel->render();

    glPopMatrix();
}
