#include <QCoreApplication>
#include <QImage>
#include <QtDebug>


// Probability of having a star with given size
//const int starSizeProbabilities[] = { 1000, 300, 100, 25, 5, 1 };
const int starSizeProbabilities[] = { 1000, 150, 20, 5, 1 };
const int starMaxSize = sizeof(starSizeProbabilities) / sizeof(int) - 1;
const int starCount = 3000;

const int textureSize = 2048;


int main(int argc, char** argv)
{
    QCoreApplication app(argc, argv);

    int starSizeProbabilitiesSum[starMaxSize + 1];;
    starSizeProbabilitiesSum[0] = starSizeProbabilities[0];
    for (int i = 1; i <= starMaxSize; i++) {
        starSizeProbabilitiesSum[i] = starSizeProbabilitiesSum[i-1] + starSizeProbabilities[i];
    }
    for (int i = 0; i <= starMaxSize; i++) {
        qDebug() << "Sum for" << i << "is" << starSizeProbabilitiesSum[i];
    }


    QImage img(textureSize, textureSize, QImage::Format_RGB32);
    img.fill(qRgb(0, 0, 0));

    for (int i = 0; i < starCount; i++) {
        int v = rand() % 250;

        int sizeP = rand() % starSizeProbabilitiesSum[starMaxSize];
        int size = 0;
        for (; size < starMaxSize; size++) {
            if (sizeP <= starSizeProbabilitiesSum[size]) {
                break;
            }
        }

        int x = rand() % textureSize;
        int y = rand() % textureSize;
        for (int dx = -size; dx <= size; dx++) {
            for (int dy = -size; dy <= size; dy++) {
                if (dx*dx + dy*dy > size*size) {
                    continue;
                }
                if (x+dx < 0 || y+dy < 0 || x+dx >= textureSize || y+dy >= textureSize) {
                    continue;
                }
                img.setPixel(x+dx, y+dy, qRgb(v, v, v));
            }
        }
    }

    img.save("space.png");

    return 0;
}
