/***************************************************************************
 *   Copyright (C) 2009 by Alexander Smirnov                               *
 *   alexander.v.smirnov@gmail.com                                         *
 *                                                                         *
 *   Copyright (C) 2011, Dmitry Chernov                                    *
 *   diman4ik.chernov@gmail.com                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/
#ifndef HUMANPLAYER_H
#define HUMANPLAYER_H

#include "checker.h"
#include "iplayer.h"


/**
	@author Alexander Smrinov <alexander.v.smirnov@gmail.com>
*/
class HumanPlayer : public IPlayer
{
public:
    HumanPlayer( Checker::Color color, QString name );
    HumanPlayer() {}
    ~HumanPlayer();

    // implement 
    virtual QString makeTurn();
    //virtual void setDice(qint8 d1, qint8 d2);
    virtual QString name() const;
    virtual void setName( const QString& name );
    virtual direction getDirection() const;
    virtual void setDirection( IPlayer::direction dir );
    virtual Checker::Color color() const { return m_color; }

private:
    Checker::Color m_color;
    QString m_name;
    
    IPlayer::direction m_direction;
};

#endif
