/***************************************************************************
 *   Copyright (C) 2009 by Alexander Smirnov                               *
 *   alexander.v.smirnov@gmail.com                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/


#include "mainwindow.h"
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <KDE/KLocale>

static const char description[] =
    I18N_NOOP("KDE Backgammon Game");

static const char version[] = "0.1";

int main(int argc, char **argv)
{
    KAboutData about("backgammon", 0, ki18n("backgammon"), version, ki18n(description),
                     KAboutData::License_GPL, ki18n("(C) 2009 Alexander Smirnov"), KLocalizedString(), 0, "alexander.v.smirnov@gmail.com");
    about.addAuthor( ki18n("Alexander Smirnov"), KLocalizedString(), "alexander.v.smirnov@gmail.com" );
    KCmdLineArgs::init(argc, argv, &about);

    KCmdLineOptions options;
    KCmdLineArgs::addCmdLineOptions(options);
    KApplication app;

    BackgammonMainWindow *widget = new BackgammonMainWindow();

    // see if we are starting with session management
    if (app.isSessionRestored())
    {
        RESTORE(BackgammonMainWindow);
    }
    else
    {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
        if (args->count() == 0)
        {
            //backgammon *widget = new backgammon;
            widget->show();
        }
        else
        {
            int i = 0;
            for (; i < args->count(); i++)
            {
                //backgammon *widget = new backgammon;
                widget->show();
            }
        }
        args->clear();
    }

    return app.exec();
}
