/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef AENGINE_H
#define AENGINE_H


/**
abstract engine for the template version
it is supposed to manipulate AbstractLegalMove and AbstractBoard

	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/

#include "legalmove.h"
class Board;
class EngineInfo;
class TimeManager;


class AEngine
{
public:
    AEngine();

    virtual ~AEngine();
     virtual const EngineInfo* getEngineInfo()const=0;
     virtual LegalMove findBestMoveFixDepth2( const Board* const pBoard, int depthLevel , int& bestScore)=0;
     virtual LegalMove findBestMoveFixTime2( const Board* const pBoard, int thinkTime, TimeManager &tm)=0;
     virtual void genPossibleMoves( QList<LegalMove > &MoveList ,const Board* const pBoard )=0;
     virtual void stopThinking()=0;
     virtual void fillBook( QList<QList<LegalMove> > &Book )=0;
     virtual void makeMove( Board*, const LegalMove& )=0;
     void printMoveList( const QList<LegalMove>& MoveList);

};

#endif
