/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef BOARDMODEL_H
#define BOARDMODEL_H

#include <QAbstractTableModel>
#include <QPoint>
#include <QVector>

/**
	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/

class Board;
class Game;
class humanPlayer;

class BoardModel : public QAbstractTableModel
{
Q_OBJECT
public:
    explicit BoardModel( Game *pGame );

    ~BoardModel();
    void setGame( Game * );
    void setPlayer( humanPlayer * );
    int rowCount ( const QModelIndex & parent = QModelIndex() ) const;
    int columnCount ( const QModelIndex & parent = QModelIndex() ) const;
    QVariant data ( const QModelIndex & index, int role = Qt::DisplayRole ) const;
    bool setData ( const QModelIndex & index, const QVariant & value, int role = Qt::EditRole );
    QVariant headerData ( int section, Qt::Orientation orientation, int role = Qt::DisplayRole ) const;
private:
    //Board * m_Board;
    Game * m_Game;
    humanPlayer *m_Player;
    QPoint currentPiece;
    QVector<QPoint> path;
private:
    bool canMove(int x, int y) const;
    int checkNextMove( const QPoint & xy , int & moveNr)const;
public slots:
    void allDataChanged();
};

#endif
