/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#include "config.h"
#include <QSettings>

// that is global function
Config& Conf() 
{
    static Config c;
    return c;
}

/*!
    \fn Config::Config()
 */
Config::Config()
{
    read();
}


Config::~Config()
{
}


/*!
    \fn Settings::read()
 */
void Config::read()
{
    QSettings qs("Piotr Banasiak","draughts");

    // here are default values implemented
    m_Level = qs.value("Level", 3 ).toInt();
    m_boardSize = qs.value("BoardSize", 8 ).toInt();
    m_Rules = qs.value("Rules", "International" ).toString();
    m_maxCaptureCompulsory = qs.value("maxCaptureCompulsory", true ).toBool();
    
    m_WhiteLevel = qs.value("WhiteLevel", 1 ).toInt();
    m_BlackLevel = qs.value("BlackLevel", 1 ).toInt();
    m_WhiteLevelType = qs.value("WhiteLevelType", "secPerMove" ).toString();//fixedDepth
    m_BlackLevelType = qs.value("BlackLevelType", "secPerMove" ).toString();
}


/*!
    \fn Settings::write()
 */
void Config::write()
{
    QSettings qs("Piotr Banasiak","draughts");
    qs.setValue("Level", m_Level);
    qs.setValue("BoardSize", m_boardSize);
    qs.setValue("Rules", m_Rules );
    //qs.sync();
    qs.setValue("WhiteLevel", m_WhiteLevel);
    qs.setValue("BlackLevel", m_BlackLevel);
    qs.setValue("WhiteLevelType", m_WhiteLevelType);
    qs.setValue("BlackLevelType", m_BlackLevelType);
}



