/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef ENGINEINFO_H
#define ENGINEINFO_H

/**
how many nodes analyzed, how deep. and so on

  @author Piotr Banasiak <piotrbanasiak@onet.pl>
*/

#include <QTime>

class EngineInfo
{
public:
    EngineInfo();

    ~EngineInfo();
    void print();
    void reset();

    int leafNodes;
    int maxDepth;
    int Depth;
    int score;
    int nodes;
    int nodesCut;
    int unnecessarySacryfice;
    int hashNodes;
    int elapsed;
    void start();
    void stop(int score);
    float nodesPerSecond()const;
    
    private:
    QTime time;
};

#endif
