/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef GAME_H
#define GAME_H

/**
contains GameHistory, and possibility to give Current board. and current moveList.

	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/
#include <QObject>
#include <QList>
#include "legalmove.h"


///@todo probably the following (board and move) two should be abstract
class Board;
class AEngine;
class QFile;
class EngineInfo;
class AEngine;
class LegalMove;

class Game: public QObject
{
Q_OBJECT
public:
enum
{
   blackWin,
   whiteWin,
   draw
   //humanPlayer,
   //computerPlayer
};
    ///@todo if it is qobject should have parent to take care of destroying
    explicit Game(AEngine *engine);

    ~Game();
    Board* getCurrentBoard() const;
    const LegalMove *const getLastMove() const;
    const QList<LegalMove>* getPossibleMoves();
    void setEngine( AEngine *engine );
    bool makeMove( LegalMove &LM );
    void newGame( );
    bool takeBack();
    bool forward();
    void moveTo( int moveNr);
    bool getStatus( int &whiteM, int& whiteK, int &blackM, int& blackK, int& moveNr, int&toDraw);
    int getCurrentMove() const{return currentMove;}
    bool isGameOver();
    bool save(QFile & file);
    bool load(QFile & file);
    bool loadBook(QFile & file);
    AEngine* pAbstractEngine;

    LegalMove getBookMove(bool &found);
    const QList<LegalMove>&  getMoveHistory() const{return moveHistory;}
    //void run();
    
    //QList<Move> moveList;
private:
    
    QList<Board*>  gameHistory;
    QList<LegalMove> moveHistory;
    QList<QList<LegalMove> > Book;
    

    QList<LegalMove> possibleMoves;//from current position
    int currentMove;
    //int whitePlayer,blackPlayer;
    //bool humanVsHuman;
signals:
    void gameOver( int moveNr );
    void documentChanged( );
    void historyChanged( int oldSize, int newSize );
    void currentMoveChanged(int);
    void engineInfoChanged( const EngineInfo * );
};
//QDataStream & operator<<( QDataStream &, QList<LegalMove> moveHistory );
QDataStream & operator<<( QDataStream & out, const LegalMove& LM );
QDataStream & operator>>( QDataStream & in, LegalMove& LM );
#endif
