/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/

#ifndef LEGALMOVE_H
#define LEGALMOVE_H

#include <QVector>
#include <QPoint>

/**
  *@author Piotr Banasiak
The class defines single legal move in the game
from start to end, together with all intermediate positions
and taken opposite pieces (if any)
*/


//-----------------------------------------
class LegalMove
{
public: 
	LegalMove();
	LegalMove(const LegalMove & LM);
	LegalMove(const QPoint &s,const QPoint &d);
 
  void print() const; 
	~LegalMove();
  bool operator==(const LegalMove&)const ;


	void insPath(const QPoint &xy,int count);
	void insTaken(const QPoint &xy,int count);
	int comparePart(const QVector<QPoint> &UInput, const QPoint & next)const;
	QVector<QPoint> path;//from the start to the end
	QVector<QPoint> takenPieces;
  QString toString() const; 
};
#endif
