/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/

#ifndef LEGALMOVE64_H
#define LEGALMOVE64_H

/**
  *@author Piotr Banasiak
  LegalMove implemented as template
  */

#include <QtGlobal>


template <class T>
class LegalMoveT 
{
public: 
  LegalMoveT()
  {
    src=0;
    dst=0;
    captured=0;
    killer=0;
    value=-4000000;
    used=0;
  }
  //-------------------------------
  LegalMoveT & operator=(const LegalMoveT & LM)
  {
    src=LM.src;
    dst=LM.dst;
    captured=LM.captured;
    
    value=LM.value;
    used=LM.used;
    killer=LM.killer;
    return *this;
  }
  //-------------------------------
	~LegalMoveT(){}
  //-------------------------------
  bool operator==(const LegalMoveT & LM)const
  {
    if( src!=LM.src )return false;
    if( dst!=LM.dst )return false;
    if( captured!=LM.captured )return false;
    
    return true;
  }
  //--------------------------------------
  bool operator<(const LegalMoveT& LM2)const
  {
    //reverse order, we want highest scores at begin of list
    if( value == LM2.value or (value<=-4000000 and LM2.value<=-4000000) )
       return killer>LM2.killer;
       
    return value > LM2.value;
  }
  //--------------------------------------
  int takenPieces() const
  {
    int cnt=0;
    T shift=captured;
    T M=1;
    while( shift )
    {
        if( shift & M) cnt++;
        shift >>= 1;
    }
    return cnt;
  }
  //--------------------------------------
  int src;
  int dst;
  T captured;///@todo we need it only during moves generation
  int value;
  int killer;
  int used;// for PV sorting
};

#endif
