/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef NETPLAYER_H
#define NETPLAYER_H

#include <QAbstractSocket>
#include <QString>
#include <QObject>
#include "legalmove.h"
#include "abstractplayer.h"

/**
	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/
class netPlayer : public AbstractPlayer
{
Q_OBJECT
public:
    netPlayer(QObject *parent , QAbstractSocket *pS);

    ~netPlayer();
    void connectTo();
    void sendGameReq( bool followerIsWhite );
    void yourMove( const LegalMove *lastMove );
    void acceptGame();
    void rejectGame();
    virtual enum playerType getType()const {return networkType;}
private:
   bool readF( QDataStream& in );
   QAbstractSocket *pSocket;
   //char m_name;
   
public slots:
    //void onNewConnection();
    //void onNewConnection(QAbstractSocket::SocketState socketState);
    void onState( QAbstractSocket::SocketState );
    void onError( QAbstractSocket::SocketError);
    void onReadyRead();
signals:
    void moveFinished(LegalMove);
    void gameReq( bool normal, bool followerIsWhite );
    void gameAcc(bool);
};



#endif
