/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef NETWORKGAMEDIALOG_H
#define NETWORKGAMEDIALOG_H

#include "ui_networkgame.h"
#include <QAbstractSocket>

class QTcpSocket;
class QTcpServer;
/**
	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/
class networkGameDialog : public QDialog
{
Q_OBJECT
public:
    networkGameDialog(QWidget *parent = 0);

    ~networkGameDialog();
private:
    Ui::networkGame ui;
    QTcpSocket *pSocket;
    QTcpServer *tcpServer;
private slots:
    void onConnectTo();
    void onWait();
    void onTerminate();
    void onConnected();
    void onDisconnected();
    void onNewConnection();
    void onSocketDestroyed();
    void onSocketError(QAbstractSocket::SocketError);
    void onDialogFinished(int);
signals:
    void disconnected();
    void connected(QAbstractSocket*);
};

#endif
