/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef NEWGAMEDIALOG_H
#define NEWGAMEDIALOG_H

/**
	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/

#include "ui_newgame.h"
#include "abstractplayer.h"
class QButtonGroup;
class engineDetailsWidget;

class newGameDialog : public QDialog
{
Q_OBJECT
public:
    newGameDialog(QWidget *parent = 0);

    ~newGameDialog();
    void setNetPlayerEnabled(bool);
    void setWhitePlayer( AbstractPlayer *p, bool fixNetPlayer);
    void setBlackPlayer( AbstractPlayer *p, bool fixNetPlayer);
    void setNetPlayWhite(bool isWhite);
    enum AbstractPlayer::playerType getWhitePlayer()const;
    enum AbstractPlayer::playerType getBlackPlayer()const;
private:
    Ui::newGame ui;
    QButtonGroup *buttonGroup;
    engineDetailsWidget *whiteDetails;
    engineDetailsWidget *blackDetails;
private slots:
    void onDialogFinished(int);
    void onClicked(int id);
    void onDetails();
};

#endif
