/*
 * Copyright 2008 Marijn Kruisselbrink <m.kruisselbrink@student.tue.nl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef CONFIGWIDGET_H
#define CONFIGWIDGET_H

#include "ui_ConfigWidget.h"

class KConfigGroup;

class ConfigWidget : public QWidget, private Ui_ConfigWidget
{
    Q_OBJECT
public:
    ConfigWidget();
    void applyConfiguration();
    void loadConfiguration(const KConfigGroup& config);

    enum HitEffect {
        HE_Stun = 0,
        HE_Die,
        HE_None
    };

    enum GameType {
        GT_Points = 0,
        GT_Time,
        GT_PointsTime
    };

    enum SpawnType {
        ST_Basket = 0,
        ST_Random
    };

    enum HoldMode {
        HM_Hold = 0,
        HM_Shoot,
        HM_Points
    };

    enum FruitType {
        FT_Apple = 0,
        FT_Lemon,
        FT_Orange,
        FT_Pineapple,
        FT_Strawberry
    };
private slots:
    void teamsToggled(bool enabled);
    void fourTeamsToggled(bool enabled);
    void hitEffectChanged(int idx);
    void startButtonClicked();
    void gameTypeChanged(int idx);
private:
    KConfig presetGames;
};

#endif // CONFIGWIDGET_H
