/*
    gamefustatusbar.cpp - Gamefu Status Bar

    Copyright (c) 2006 by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#include "gamefustatusbar.h"

// Qt includes
#include <qlabel.h>
#include <qlayout.h>

// KDE includes
#include <klocale.h>

class GamefuStatusBar::Private
{
public:
	Private()
	 : labelCollectionTotal(0)
	{}

	QLabel *labelCollectionTotal;
};

GamefuStatusBar::GamefuStatusBar(QWidget *parent)
 : KDE::StatusBar(parent), d(new Private)
{
	setMaximumHeight(22);

	d->labelCollectionTotal = new QLabel(this);
	d->labelCollectionTotal->setText( i18n( "%n ROM", "%n ROMs", 0) );
	d->labelCollectionTotal->setAlignment( Qt::AlignCenter );
	d->labelCollectionTotal->setSizePolicy( QSizePolicy::Maximum, QSizePolicy::Fixed );

	addWidget(d->labelCollectionTotal);
}


GamefuStatusBar::~GamefuStatusBar()
{
	delete d;
}

void GamefuStatusBar::updateCollectionTotal(int totalRoms)
{
	d->labelCollectionTotal->setText( i18n( "%n ROM", "%n ROMs", totalRoms ) );
}

#include "gamefustatusbar.moc"
