/*
    gamefuplugin.cpp - Base class for plugins.

    Copyright (c) 2006      by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#include "gamefuplugin.h"

// Qt includes
#include <qguardedptr.h>

// KDE includes
#include <kplugininfo.h>

namespace Gamefu
{

class Plugin::Private
{
public:
	Private()
	 : pluginInfo(0)
	{}

	KPluginInfo *pluginInfo;
};

Plugin::Plugin(KInstance *instance, QObject *parent, const char *name)
 : QObject(parent, name), KXMLGUIClient(), d(new Private)
{
	// Set instance is needed for KXMLGUIClient to plug into the right instance.
	setInstance( instance );
}

Plugin::~Plugin()
{
	delete d;
}

void Plugin::setPluginInfo(KPluginInfo *info)
{
	d->pluginInfo = info;
}

KPluginInfo *Plugin::pluginInfo()
{
	return d->pluginInfo;
}

KPluginInfo *Plugin::pluginInfo() const
{
	return d->pluginInfo;
}

QString Plugin::displayName() const
{
	return pluginInfo()->name();
}

}

#include "gamefuplugin.moc"
