/*
    nesrommetadata.h - Extract metadata(information) from NES ROM file.

    Copyright (c) 2005      by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#ifndef NESROMMETADATA_H
#define NESROMMETADATA_H

#include <defaultrommetadata.h>

/**
 * Extract metadata(information) from NES ROM file.
 * 
 * @author Michaël Larouche <larouche@kde.org>
*/
class NesRomMetaData : public Gamefu::DefaultRomMetaData
{
public:
	NesRomMetaData();
	
	~NesRomMetaData();
	
	virtual Gamefu::RomMetaInformation extractMetaInformation(KFileItem* item);
	virtual Gamefu::RomMetaInformation extractMetaInformation(QIODevice *device);

};

#endif
