#ifndef PEG_H
#define PEG_H

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qimage.h>
#include <qmovie.h>
#include <qcanvas.h>
#include <stdlib.h>
#include <qptrstack.h>
#include "historypart.h"
using namespace std;
/**
@author Samuel Hoffstaetter
*/

extern const int numCols;
extern const int numRows;
extern const int pegsize;
extern const int numFrames;
extern const int advancePd;
extern const int advancePdFast;

void showmsg(int num);

class PegSprite : public QCanvasSprite {

public:
PegSprite(QCanvasPixmapArray *mov, QCanvas *canvas) : QCanvasSprite(mov, canvas) {
        randomize();
    }

    ~PegSprite() {}

    void advance(int count) {
        setFrame((frame() + count) % frameCount());
    }


    void randomize() {
        setFrame((int)(rand()/(double)RAND_MAX*frameCount()));
    }
}
;

class Peg {
public:
    Peg(QCanvas *canv = 0, int row = 0, int col = 0, Peg **pegArr = 0, QCanvasPixmapArray *mov = 0);
    ~Peg();
    int getRow();
    int getCol();
    void destroy();
    static int convert(int row, int col);
    HistoryPart* moveTo(int row, int col);
    void moveBack();
    PegSprite* getSprite();

protected:
    HistoryPart* performMove(int toRow, int toCol);
    bool checkLegalMove(int toRow, int toCol);
    int curRow, curCol;
    Peg **pegArray;
    PegSprite *sprite;
    int pegHeight;
    int pegWidth;
};
#endif
