/*
    Copyright 2009  Stanislas Marquis <smarquis@chaosorigin.com>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ZODIACORE_JSON_H
#define ZODIACORE_JSON_H

#define JSON_END        0

#define JSON_LBRACE     1
#define JSON_RBRACE     2

#define JSON_LBRACKET   3
#define JSON_RBRACKET   4

#define JSON_STRING     5
#define JSON_NUMBER     6

#define JSON_COLON      7
#define JSON_COMMA      8

#define JSON_TRUE       9
#define JSON_FALSE      10
#define JSON_NULL       11

int json_parse( char*, char** );

Bool json_string( char*, char**, char**, char** );

Bool json_number( char*, char**, char**, char** );

int json_number_int( char*, char* );

double json_number_float( char*, char* );

#ifndef NDEBUG

void json_unittest();

#endif /* !NDEBUG */

#endif /* !ZODIACORE_JSON_H */
