/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_BLENDER_STACKER_TEXTUREBAR_H
#define KOLF_BLENDER_STACKER_TEXTUREBAR_H

#include <QGraphicsItem>

//The components of the BlenderStacker use the prefix "Bs".
namespace Kolf
{
	class BsTextureItem : public QObject, public QGraphicsPixmapItem
	{
		Q_OBJECT
		public:
			BsTextureItem(const QString& key);

			QString key() const;
			void setKey(const QString& key);
		Q_SIGNALS:
			void moveRequest(Kolf::BsTextureItem* item, qreal dy);
		protected:
			virtual void mousePressEvent(QGraphicsSceneMouseEvent* event);
			virtual void mouseMoveEvent(QGraphicsSceneMouseEvent* event);
		private:
			QString m_key;
			QGraphicsRectItem* m_outline;
	};

	class BsTextureBar : public QObject, public QGraphicsLineItem
	{
		Q_OBJECT
		public:
			BsTextureBar();
			void setHeight(qreal height);
		Q_SIGNALS:
			void itemAdded(int index);
			void itemRemoved(int index);
			void itemChanged(int index);
		public Q_SLOTS:
			void addKey(const QString& key);
			void removeKey(const QString& key);
		private Q_SLOTS:
			void moveRequest(Kolf::BsTextureItem* item, qreal dy);
		private:
			void doLayout();

			QList<Kolf::BsTextureItem*> m_items;
			qreal m_height;
	};
}

#endif // KOLF_BLENDER_STACKER_TEXTUREBAR_H
