/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_HMCREATOR_FILLBUTTON_H
#define KOLF_HMCREATOR_FILLBUTTON_H
#include "hmcreator-toolbutton.h"

namespace Kolf
{
	class FillButton : public ToolButton
	{

		Q_OBJECT
		public:
			explicit FillButton(QWidget* parent = 0);
			~FillButton();

		public Q_SLOTS:
			void changeGradientType(const Qt::BrushStyle& style) 
				{m_gradientType = style;}
			void changeGradientStops(const QGradientStops& stops)
				{m_gradientStops = stops;}
			void changeGradientSpread(const QGradient::Spread& spread)
		 		{m_gradientSpread = spread;}

		protected:
			virtual void handleMouseMoved(DrawingBoard* board, QMouseEvent* event);
			virtual void handleMouseReleased(DrawingBoard* board, QMouseEvent* event);

		private:
			void drawPoint(QPainter* painter, const QPointF& pos, qreal radius);
			QGradientStops m_gradientStops;
			QGradient::Spread m_gradientSpread;
			Qt::BrushStyle m_gradientType;
			QPair<QPointF, QPointF> m_gradientPoints;
	};
}
#endif // KOLF_HMCREATOR_FILLBUTTON_H
