/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_HMCREATOR_PENBUTTON_H
#define KOLF_HMCREATOR_PENBUTTON_H
#include "hmcreator-toolbutton.h"
#include <QColor>

namespace Kolf
{
	class PenButton : public ToolButton
	{
		Q_OBJECT
		public:
			explicit PenButton(QWidget* parent = 0);
			~PenButton();

		public Q_SLOTS:
			void setPenColor(const QColor& color) {m_penColor = color;}
			void setPenWidth(int penWidth) {m_penWidth = penWidth;}

		protected:
			virtual void handleMousePressed(DrawingBoard* board, QMouseEvent* event);
			virtual void handleMouseMoved(DrawingBoard* board, QMouseEvent* event);
			virtual void handleMouseReleased(DrawingBoard* board, QMouseEvent* event);
		private:
			void paint(DrawingBoard* board, QMouseEvent* event);
			QPointF m_penLastPoint;
			QColor m_penColor;
			int m_penWidth;
	}; 
}
#endif // KOLF_HMCREATOR_PENBUTTON_H
