/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_HMCREATOR_PENCONFWIDGET_H
#define KOLF_HMCREATOR_PENCONFWIDGET_H
#include <QWidget>

namespace Kolf
{
	class ToolButton;
	class PenConfWidget : public QWidget
	{
		Q_OBJECT
		public:
			PenConfWidget(ToolButton* button, QWidget* parent);
	
		Q_SIGNALS:
			void penColorChanged(const QColor& color);
			void penWidthChanged(int value);
	
		private Q_SLOTS:
			void changePenColor(int value);
	
		private:
			void setupUI();
			void createPixmap();
			QColor m_penColor;
			QPixmap m_pixmap;
			ToolButton* m_button;
	};
}
#endif // KOLF_HMCREATOR_PENCONFWIDGET_H
