/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_HMCREATOR_TOOLBOXCONFWIDGET_H
#define KOLF_HMCREATOR_TOOLBOXCONFWIDGET_H
#include <QWidget>

namespace Kolf
{
	class EraserConfWidget;
	class FillConfWidget;
	class PenConfWidget;
	class ToolBox;
	class ToolButton;
	class ToolBoxConfWidget : public QWidget
	{
		Q_OBJECT
		public:
			explicit ToolBoxConfWidget(ToolBox* toolBox, QWidget* parent = 0);
	
		public Q_SLOTS:
			void buttonChanged(ToolButton* button);

		private:
			void setupUI();
			void showWidget(QWidget* widget);

			QList<QWidget*> m_widgetList;
			FillConfWidget* m_fillWidget;
			PenConfWidget* m_penWidget;
			EraserConfWidget* m_eraserWidget;
			ToolBox* m_toolBox;
	};
}

#endif // KOLF_HMCREATOR_TOOLBOXCONFWIDGET_H
