/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OBJECT_COURSEMETA_H
#define KOLF_OBJECT_COURSEMETA_H

#include <QPointer>
#include "object.h"

namespace Kolf
{

	class WallObject;
	typedef QPointer<Kolf::WallObject> WallObjectPointer;

	//This object represents some global properties of the course:
	// * The position of this object is the point where players should spawn the balls.
	// * It saves whether the object should provide a course boundary.
	class CourseMetaObject : public Kolf::Object
	{
		Q_OBJECT
		Q_PROPERTY(bool CourseBoundary READ hasCourseBoundary WRITE setCourseBoundary)

		public:
			CourseMetaObject(dWorldID worldID, dSpaceID spaceID);
			virtual ~CourseMetaObject();

			bool hasCourseBoundary() const;
			void setCourseBoundary(bool hasCourseBoundary);
		protected:
			virtual Overlay* createOverlay();
		private:
			bool m_hasCourseBoundary;
			QList<Kolf::WallObjectPointer> m_courseBoundaryComponents;
	};
}

#endif // KOLF_OBJECT_COURSEMETA_H
