/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OBJECT_PUDDLE_H
#define KOLF_OBJECT_PUDDLE_H

#include "object.h"
class QString;

namespace Kolf
{

	class PuddleObject: public Kolf::Object
	{
		Q_OBJECT
		//TODO:I hope this property will be moved into Kolf::Object in the future to implement a general texture rendering method for 3d view.
		Q_PROPERTY(QString PathToTexture READ pathToTexture WRITE setPathToTexture)

		public:
			PuddleObject(dWorldID worldID, dSpaceID spaceID);
			~PuddleObject();
			virtual void createSpatialGeometry();
			virtual float* getNormalGeometry();
			virtual float* getVertexGeometry();
			QString pathToTexture() {return m_pathToTexture;}
			void setPathToTexture(const QString& path);

		protected:
			virtual Overlay* createOverlay();

		private:
			QString m_pathToTexture;
			float *m_vertexArray, *m_normalArray;

	};

}
#endif
