/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "gameui-dockwidget.h"
#include "../elements/scene.h"

Kolf::GameUIDockWidget::GameUIDockWidget(const QString& title)
	: QDockWidget(title)
	, m_scene(0)
	, m_preferredArea(Qt::LeftDockWidgetArea) //some random default
{
}

Qt::DockWidgetArea Kolf::GameUIDockWidget::preferredArea() const
{
	return m_preferredArea;
}

void Kolf::GameUIDockWidget::setPreferredArea(Qt::DockWidgetArea area)
{
	m_preferredArea = area;
}

void Kolf::GameUIDockWidget::setScene(Kolf::Scene* scene)
{
	Kolf::Scene* oldScene = m_scene;
	m_scene = scene;
	currentSceneChanged(oldScene, scene);
}

void Kolf::GameUIDockWidget::currentSceneChanged(Kolf::Scene* oldScene, Kolf::Scene* newScene)
{
	Q_UNUSED(oldScene)
	Q_UNUSED(newScene)
}

#include "gameui-dockwidget.moc"
