/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "gameui-pagewidget.h"

#include <QStackedLayout>

Kolf::GameUIPageWidget::GameUIPageWidget(const QString& label)
	: m_scene(0)
	, m_label(label)
{
}

Kolf::Scene* Kolf::GameUIPageWidget::currentScene() const
{
	return m_scene;
}

QString Kolf::GameUIPageWidget::label() const
{
	return m_label;
}

void Kolf::GameUIPageWidget::setScene(Kolf::Scene* scene)
{
	Kolf::Scene* oldScene = m_scene;
	m_scene = scene;
	currentSceneChanged(oldScene, scene);
}

void Kolf::GameUIPageWidget::setContent(QWidget* contentWidget)
{
	QStackedLayout* layout = new QStackedLayout;
	layout->addWidget(contentWidget);
	setLayout(layout);
}

void Kolf::GameUIPageWidget::currentSceneChanged(Kolf::Scene* oldScene, Kolf::Scene* newScene)
{
	Q_UNUSED(oldScene)
	Q_UNUSED(newScene)
}

void Kolf::GameUIPageWidget::showEvent(QShowEvent* event)
{
	Q_UNUSED(event)
	emit shown();
}

void Kolf::GameUIPageWidget::hideEvent(QHideEvent* event)
{
	Q_UNUSED(event)
	emit hidden();
}

#include "gameui-pagewidget.moc"
