/***************************************************************************
 *   Copyright 2008-2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "player-local.h"
#include "../elements/ball.h"
#include "../elements/putter.h"
#include "../elements/scene.h"

Kolf::LocalPlayer::LocalPlayer(const QString& name, unsigned int holeCount)
	: Kolf::Player(name, holeCount)
{
}

Kolf::LocalPlayer::~LocalPlayer()
{
}

Kolf::Putter* Kolf__LocalPlayer__findPutter(Kolf::Object* object)
{
	//TODO: This is an awful hack which will disappear once the putter is redesigned.
	return reinterpret_cast<Kolf::Scene*>(object->scene())->putter();
}

void Kolf::LocalPlayer::giveControl()
{
	ball()->show();
	Kolf::Putter* putter = Kolf__LocalPlayer__findPutter(ball());
	putter->show(ball());
	connect(putter, SIGNAL(putted(Kolf::Ball*)), this, SLOT(putted()));
}

void Kolf::LocalPlayer::takeControl()
{
	Kolf::Putter* putter = Kolf__LocalPlayer__findPutter(ball());
	if (ball() == putter->ball())
		putter->hide();
	putter->disconnect();
}

void Kolf::LocalPlayer::putted()
{
	setCurrentScore(currentScore() + 1);
	takeControl();
}

#include "player-local.moc"
