/***************************************************************************
 *   Copyright 2008-2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "view2d.h"
#include "../elements/putter.h"
#include "../elements/scene.h"

Kolf::View2D::View2D()
	: m_scene(0)
{
	//invert Y axis to get a right-handed coordinate system
	scale(1.0, -1.0);
	//view initialisation
	setBackgroundBrush(Qt::white);
	setMinimumSize(100, 100);
	setMouseTracking(true);
	setRenderHint(QPainter::Antialiasing);
}

void Kolf::View2D::setScene(Kolf::Scene* scene)
{
	if (m_scene == scene)
		return;
	m_scene = scene;
	QGraphicsView::setScene(scene);
	if (m_scene)
		resizeEvent(0);
}

void Kolf::View2D::leaveEvent(QEvent*)
{
	if (m_scene)
		m_scene->putter()->mouseLeaveEvent();
}

void Kolf::View2D::resizeEvent(QResizeEvent*)
{
	if (m_scene)
		fitInView(m_scene->sceneRect(), Qt::KeepAspectRatio);
}

#include "view2d.moc"
