/***************************************************************************
 *   Copyright 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OBJECT_CIRCLEBLOCK_H
#define KOLF_OBJECT_CIRCLEBLOCK_H

#include "object.h"

namespace Kolf
{
	class CircleShape;

	///Note: The reference point for this object is its center.
	class CircleBlockObject : public Kolf::Object
	{
		Q_OBJECT
		Q_PROPERTY(qreal Radius READ radius WRITE setRadius)
		public:
			CircleBlockObject(b2World* world);

			qreal radius() const;
			void setRadius(qreal radius);
		protected:
			virtual Kolf::Overlay* createOverlay();
		private:
			Kolf::CircleShape* m_shape;
			QGraphicsEllipseItem* m_item;
	};
}

#endif // KOLF_OBJECT_CIRCLEBLOCK_H
