/***************************************************************************
 *   Copyright 2008, 2009, 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OVERLAYHANDLE_H
#define KOLF_OVERLAYHANDLE_H

#include <QGraphicsPathItem>
#include <QObject>

namespace Kolf
{
	class OverlayHandle : public QObject, public QGraphicsPathItem
	{
		Q_OBJECT
		public:
			enum Shape
			{
				SquareShape,
				CircleShape,
				TriangleShape
			};

			OverlayHandle(Shape shape, QGraphicsItem* parent);
		Q_SIGNALS:
			void moveStarted();
			void moveRequest(const QPointF& targetScenePos);
			void moveEnded();
		protected:
			virtual void hoverEnterEvent(QGraphicsSceneHoverEvent* event);
			virtual void hoverLeaveEvent(QGraphicsSceneHoverEvent* event);
			virtual void mousePressEvent(QGraphicsSceneMouseEvent* event);
			virtual void mouseMoveEvent(QGraphicsSceneMouseEvent* event);
			virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent* event);
	};
}

#endif // KOLF_OVERLAYHANDLE_H
