/***************************************************************************
 *   Copyright 2009, 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_GAME_NORMAL_H
#define KOLF_GAME_NORMAL_H

#include "game.h"
class QTimer;

namespace Kolf
{
	class BallObject;

	class NormalGame : public Kolf::Game
	{
		Q_OBJECT
		public:
			NormalGame(Kolf::Course* course, Kolf::Interface* interface);

			Kolf::Player* addLocalPlayer(const QString& name, int hue);
		protected:
			virtual void bootHole(Kolf::Hole* hole);
			virtual void shutdownHole(Kolf::Hole* hole);
		private Q_SLOTS:
			void ballObjectCreated(Kolf::BallObject* ballObject);
			void ballStopped();
			void putted(Kolf::BallObject* ball);
			void selectNextPlayer();
			void selectNextHole();
		private:
			Kolf::BallObject* ballForPlayer(Kolf::Player* player) const;
			void callDelayed(const char* localSlot);

			QTimer* m_timer;
			int m_currentPlayerIndex;
	};
}

#endif // KOLF_GAME_NORMAL_H
