/***************************************************************************
 *   Copyright 2008, 2009, 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "player-local.h"
#include "../base/object-ball.h"
#include "../base/putter.h"

Kolf::LocalPlayer::LocalPlayer(const QString& name, int hue)
	: Kolf::Player(name, hue)
	, m_attachedBall(0)
{
}

bool Kolf::LocalPlayer::hasControl() const
{
	if (m_attachedBall)
	{
		if (m_attachedBall == ball(false))
			return true;
		else
		{
			m_attachedBall = 0;
			return false;
		}
	}
	else
		return false;
}

void Kolf::LocalPlayer::giveControl()
{
	Kolf::BallObject* ball = this->ball();
	Kolf::Putter* putter = this->putter();
	if (putter && ball)
	{
		ball->show();
		putter->setBall(ball);
	}
}

void Kolf::LocalPlayer::takeControl()
{
	Kolf::Putter* putter = this->putter();
	if (putter)
		if (putter->ball() == ball())
			putter->setBall(0);
}

void Kolf::LocalPlayer::slotAttached(Kolf::BallObject* ball)
{
	m_attachedBall = ball;
}

void Kolf::LocalPlayer::slotDetached(Kolf::BallObject* ball)
{
	if (m_attachedBall == ball)
		m_attachedBall = 0;
}

#include "player-local.moc"
