/***************************************************************************
 *   Copyright 2008, 2009, 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_PLAYER_LOCAL_H
#define KOLF_PLAYER_LOCAL_H

#include "player.h"

namespace Kolf
{
	/**
	 * \class LocalPlayer
	 * \since 2.0
	 *
	 * This class represents a player that is playing at the local machine, i.e. makes use of the putter interface to set the ball velocity vector when it is his turn.
	 */
	class LocalPlayer : public Kolf::Player
	{
		Q_OBJECT
		public:
			LocalPlayer(const QString& name, int hue);
			virtual bool hasControl() const;
		public Q_SLOTS:
			virtual void giveControl();
			virtual void takeControl();
		private Q_SLOTS:
			void slotAttached(Kolf::BallObject* ball);
			void slotDetached(Kolf::BallObject* ball);
		private:
			mutable void* m_attachedBall;
	};
}

#endif // KOLF_PLAYER_LOCAL_H
