/***************************************************************************
 *   Copyright 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "window.h"
#include "interface.h"
#include "scorecard.h"
#include "../engine/game.h"

Kolf::Window::Window()
	: m_game(0)
	, m_interface(new Kolf::Interface(this))
	, m_scoreCard(new Kolf::ScoreCard)
{
	setupGUI(StandardWindowOptions(Default) & ~StatusBar, QString());
	addDockWidget(Qt::RightDockWidgetArea, m_scoreCard);
}

Kolf::Interface* Kolf::Window::interface() const
{
	return m_interface;
}

void Kolf::Window::setGame(Kolf::Game* game)
{
	if (m_game == game)
		return;
	delete m_game;
	m_game = game;
	m_scoreCard->setGame(game);
	//start game
	game->setCurrentHoleIndex(0);
}

#include "window.moc"
