#ifndef _H_KGPROJECT_H_
#define _H_KGPROJECT_H_

#include <QWidget>
#include <KTabWidget>
#include <QTreeView>
#include <QVBoxLayout>
#include <KIcon>
#include <QStandardItem>
#include <QStandardItemModel>
#include <QList>

#include "KGLevelEditor.h"
#include "KGGameData.h"

class KGProject: public QTreeView
{
Q_OBJECT
    QTreeView *treeView;
    KGGameData *m_gameData;
public:
    void setGameData(KGGameData *gameData);
    void changeProjectName(QString newName);
    KGTabInterface *openLevel(QString reference);
    KGTabInterface *newLevel(void);
    KGProject(QWidget *parent=0);
protected:
    void setSelection ( const QRect & rect, QItemSelectionModel::SelectionFlags command );
    void selectionChanged ( const QItemSelection & selected, const QItemSelection & deselected );
protected slots:
    void renameItem(QString oldReference, QString newReference, QString newName);
    void slotClicked(const QModelIndex &index);
    void mousePressEvent ( QMouseEvent * event );
    void keyPressEvent ( QKeyEvent * event );
    void closeEditor( QWidget * editor, QAbstractItemDelegate::EndEditHint hint );
signals:
    void itemRenamed(QString oldReference, QString newReference, QString newName);
    void tabSelected(QString reference);
};

#endif
