#ifndef _KGERASER_H_
#define _KGERASER_H_

#include <QGraphicsItem>
#include <KStandardDirs>
#include <QPainter>
#include <QSharedData>

#include "KGTile.h"
#include "KGObject.h"
 
/** 
    @author Keith Neuse<KNeuse@Gmail.com>
    This class creates tile objects which can be displayed in the level editor 
**/
class KGEraser : public QSharedData, public KGObject
{
public:

    KGEraser(QPixmap &getImage, QGraphicsItem *parent = 0);
    
    /** deconstructor **/
    virtual ~KGEraser();

    /** 
	This informs the level editor the dimensions of the tiles 
	@return a QRectF object with the dimensions
    **/
    QRectF boundingRect() const;

    /**
	changes the current image for the tile
	@param argImage = the new image
    **/
    void setImage(QPixmap &argImage);

    /**
	get the current image
	@return the QPixmap object with the image
    **/
    QPixmap &getImage(void);

    void editObject();
    QDomElement saveObject(QDomDocument &doc);
    void loadObject(QDomElement &element );
    KGObject *clone();
    QString name();
protected:
    QPixmap image;

    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);
};

#endif
