/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *   Copyright (C) 2005 by Pino Toscano      <toscano.pino@tiscali.it>     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef CONFIRMWIDGET_H
#define CONFIRMWIDGET_H

#include <QFrame>
#include <QString>
#include <QTimer>

class QLabel;
class KPushButton;
class miniProgressBar;

class confirmWidget : public QFrame
{
Q_OBJECT
	public:
		explicit confirmWidget(QWidget *parent);

		void setTimeout(int seconds);
		int timeout() const;

		void setNick(const QString &nick);

	signals:
		void accepted();
		void rejected();

	public slots:
		void startTimeout();
		void stopTimeout();

	private slots:
		void acceptClicked();
		void rejectClicked();
		void timeoutOver();

	private:
		void resetText();

		KPushButton *m_accept;
		KPushButton *m_reject;
		QLabel *m_text;
		QTimer m_timer;
		int m_timeout;
		QString m_nick;
		miniProgressBar *m_progressBar;
};

#endif
