/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *   Copyright (C) 2005 by Pino Toscano      <toscano.pino@tiscali.it>     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef KOMBINATION_ERROR_H
#define KOMBINATION_ERROR_H

// This file contains a list of all the errors we get, for example when
// validating the tiles placed by the user

// no error
static const int ERROR_NONE = 0;

// --- board validating errors --- //
static const int ERROR_NO_TILES_ADDED = 1;
// the user added no tiles
static const int ERROR_TILES_NOT_ALIGNED = 2;
// if user added more than tile, they don't form a row or column
static const int ERROR_TILE_ISOLATED = 3;
// the user added only one tile, but it's "isolated", ie not joined to other
// already placed tiles
static const int ERROR_TILES_ISOLATED = 4;
// the user added a valid word, but it's not joined to the already placed tiles
static const int ERROR_FIRST_WORD_NOT_CENTERED = 5;
// this is the first word of the actual game, but it doesn't cover the central
// position
static const int ERROR_UNCOVERED_HOLE = 6;
// there's an "hole" in the word formed by the user, and it isn't "filled" by
// an already existing tile.
// example: the user inserted: K-O-M-B-I-N-<missing>-T-I-O-N and the tiles for
// the A isn't on the board
static const int ERROR_BLANK_TILE_NOT_REPLACED = 7;
// the user placed a blank tile but forgot to set a new value to it

#endif
