/****************************************************************************
 * Copyright (C) 2007-2008 by Michal Sciubidlo <michal.sciubidlo@gmail.com> *
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License, or      *
 *   (at your option) any later version.                                    *
 ****************************************************************************/
#ifndef KOMBINATIONSCENE_H
#define KOMBINATIONSCENE_H

#include "board.h"
#include <QObject>
#include <QGraphicsScene>
#include <QGraphicsView>

class tileWidget;
class boardWidget;
class QMenu;
class blankTileDialog;
class QResizeEvent;

class KombinationScene : public QGraphicsScene
{
	Q_OBJECT

	public:
		enum Mode { InsertItem, InsertLine, InsertText, MoveItem };
		boardWidget * getBoard() { return m_boardWidget; }
		tileWidget * getTileWidget() { return m_rackWidget; }
		tileWidget * getExchangeWidget() { return m_exchangeRack; }

		//   KombinationScene(QMenu *itemMenu, QObject *parent = 0);
		explicit KombinationScene(QObject *parent = 0);
		~KombinationScene();
		void resize(int width, int height);
	private:
		QMenu *m_itemMenu;
		boardWidget * m_boardWidget;
		tileWidget * m_rackWidget;
		tileWidget * m_exchangeRack;
		blankTileDialog * m_dlg;
};

class KombinationView : public QGraphicsView
{
	public:
		KombinationView( KombinationScene* scene, QWidget *parent );
	private:
		virtual void resizeEvent( QResizeEvent *ev );
		KombinationScene* m_scene;
};

#endif
