/***************************************************************************
 *   Copyright (C) 2007 by Albert Astals Cid <aacid@kde.org>               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef MESSAGEHANDLER_H
#define MESSAGEHANDLER_H

#include <kombination_export.h>

#include <QTextStream>
#include <QMap>

class QTcpSocket;

class message
{
	public:
		QString type;
		QMap<QString, QString> data;
};

class KOMBINATION_EXPORT messageHandler : public QObject
{
Q_OBJECT
	public:
		void setSocket(QTcpSocket *socket);
		
		void sendMessage(const message &m);
	
	signals:
		void newMessage(const message &m);
	
	public slots:
		void readFromSocket();
	
	private:
		QString quote(const QString &string) const;
	
		QTextStream m_stream;
};

#endif
