/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "replacementshandler.h"

replacementsHandler::replacementsHandler()
{
}

void replacementsHandler::addReplacement(const QString &letter, const QString &replaces)
{
	if (m_replacements.contains(letter))
	{
		QStringList &list = m_replacements[letter];
		list.append(replaces);
	}
	else
	{
		QStringList list;
		list.append(replaces);
		m_replacements.insert(letter, list);
	}
}

QStringList replacementsHandler::possibleWords(const QString &simpleWord)
{
	QStringList result;
	QStringList replaceableLetters;
	QString replaceableLetter, changedWord;
	int i;
	bool found;
	
	result << simpleWord;
	
	replaceableLetters = m_replacements.keys();
	if (replaceableLetters.count() == 0) return result;
	
	i = 0;
	found = false;
	while (i < replaceableLetters.count())
	{
		if (!simpleWord.contains(replaceableLetters.at(i))) replaceableLetters.removeAt(i);
		else i++;
	}
	
	i = -1;
	while (!replaceableLetters.isEmpty())
	{
		replaceableLetter = replaceableLetters.first();
		i = simpleWord.indexOf(replaceableLetter, i + 1);
		if (i == -1)
		{
			replaceableLetters.removeAt(0);
			i = 0;
		}
		else
		{
			const QStringList &replacements = m_replacements[replaceableLetter];
			foreach (const QString &replacement, replacements)
			{
				changedWord = simpleWord;
				changedWord.replace(i, replaceableLetter.length(), replacement);
				result += possibleWords(changedWord);
			}
		}
	}
	
	// Remove the duplicates
	foreach (const QString &s, result)
	{
		int index = result.indexOf(s);
		index = result.indexOf(s, index+1);
		while (index != -1)
		{
			result.removeAt(index);
			index = result.indexOf(s, index+1);
		}
	}
	
	return result;
}
