/***************************************************************************
 *   Copyright (C) 2005-2007 by Albert Astals Cid <aacid@kde.org>          *
 *   Copyright (C) 2005 by Pino Toscano      <toscano.pino@tiscali.it>     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef TILEPOSITION_H
#define TILEPOSITION_H

#include <kombination_export.h>
#include <QMap>
class tile;

class KOMBINATION_EXPORT tilePosition
{
	public:
		tilePosition();
		tilePosition(tile *t, int x, int y);

		~tilePosition();

		void setTile(tile *t);
		tile* ourTile() const;
		const tile* ourTileC() const;

		void setX(int x);
		int x() const;

		void setY(int y);
		int y() const;
		
		QMap<QString,QString> toMap(const QString &tag) const;
		void fromMap(const QMap<QString,QString> &data, const QString &tag);

	private:
		tile *m_tile;
		int m_xpos;
		int m_ypos;
};

class KOMBINATION_EXPORT tilePositionList : public QList<tilePosition>
{
	public:
		void deleteTiles();
		tilePositionList(QList<tilePosition> t);
		tilePositionList();

		QList<tile*> tiles() const;

		/*!
		 * Removes reference to tilePosition from list if present
		 */
		void removeAtPos(int x, int y);
		
		bool contains(int x, int y) const;
		
		QMap<QString,QString> toMap() const;
		void fromMap(const QMap<QString,QString> &data);
}; 

#endif
