
/*
 *  Koware - The ancient African game, also known as Mancala, for KDE
 *  Copyright (C) 2005  Michael Collins  <michaelcollins@ivorycity.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Steet, Fifth Floor, Boston, MA  02110-1301  USA
 */


#ifndef CUP_H
#define CUP_H

#include "qpushbutton.h"
#include "qpainter.h"
#include "qpixmap.h"

class
Cup : public QPushButton
{
  Q_OBJECT
  public:
   Cup( QWidget* parent=0, int active=0);
   QPixmap cup;


  public slots:
   void setRedIndicator( int n );
   void reset(int n);

   inline int getNumber()         { return number; }
   inline void setNumber( int n ) { number=n;      }
   inline void incNumber()        { number++;      }
   inline void incIndicator()     { indicator++;   }
   inline void setIndicator(int i){ indicator = i; }
   inline void moveEvent( QMoveEvent* ){ update(); }

  protected:
  void paintEvent( QPaintEvent* );

  private:
   void createMask();
   int number;
   int indicator;
   int movecolor;

};

#endif

