/*
 *  Koware - The ancient African game, also known as Mancala, for KDE
 *  Copyright (C) 2005  Michael Collins  <michaelcollins@ivorycity.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Steet, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <stdio.h>
#include "owarewizard.h"
#include "qpainter.h"
#include <kapplication.h>
#include <kstandarddirs.h>
#include <kglobalsettings.h>

OwareWizard::OwareWizard(QWidget* parent, const char* name )
: QWidget( parent, name )
{
  setFixedSize(186,200);
  resting.load(  locate("imgs","mask.png"),     "PNG" );
  thinking.load( locate("imgs","maskopen.png"), "PNG" );

  //setUpdatesEnabled(true);

  state=RESTING;

  setBackgroundPixmap(*parentWidget()->backgroundPixmap());
  setBackgroundOrigin(ParentOrigin);

  buffer = new QPixmap(width(),height());
  drawBackground();

  //setResting();
}

void
OwareWizard::setResting()
{
  state = RESTING;
  drawMask();
  update();
}

void
OwareWizard::setThinking()
{
  state = THINKING;
  drawMask();
  update();
}


void
OwareWizard::drawBackground()
{
  QPainter p;
  p.begin(buffer);
  p.drawPixmap(0,0,*backgroundPixmap(),x(),y(),width(),height());
  p.end();
}

void
OwareWizard::drawMask()
{
  QPainter p;
  p.begin(buffer);
  p.drawPixmap(0,0,*backgroundPixmap(),x(),y(),width(),height());
  if( state==RESTING) p.drawPixmap( 0,0,resting  );
  else                p.drawPixmap( 0,0,thinking );
  p.end();
}

void
OwareWizard::paintEvent( QPaintEvent* )
{
  bitBlt(this,0,0,buffer,0,0,width(),height());

  //QPainter p;
  //p.begin(this);
  //p.drawPixmap( 0,0, *buffer  );
  //p.end();
  
}

#include "owarewizard.moc"



