/*
 *  Koware - The ancient African game, also known as Mancala, for KDE
 *  Copyright (C) 2005  Michael Collins  <michaelcollins@ivorycity.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Steet, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef OWAREWIZARD_H
#define OWAREWIZARD_H

#include "qwidget.h"
#include "qpixmap.h"


#define RESTING  0
#define THINKING 1

class
OwareWizard : public QWidget
{
  Q_OBJECT

  public:
  OwareWizard( QWidget* parent = 0, const char* name =0 );
  QPixmap  resting;
  QPixmap  thinking;
  int      state;
  QPixmap* buffer;

  inline void resizeEvent(QResizeEvent*){ drawBackground(); drawMask(); };
  void drawBackground();
  void drawMask();

  public slots:
  void setResting();
  void setThinking();
  inline void backgroundChanged(){ drawBackground(); drawMask(); };

  protected:
  void paintEvent( QPaintEvent* );
};

#endif

