/*
 *  Koware - The ancient African game, also known as Mancala, for KDE
 *  Copyright (C) 2005  Michael Collins  <michaelcollins@ivorycity.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Steet, Fifth Floor, Boston, MA  02110-1301  USA
 */


#ifndef SCORELABEL_H
#define SCORELABEL_H

#include "qwidget.h"
#include "qimage.h"
#include "qpixmap.h"

class
ScoreLabel : public QWidget
{
  Q_OBJECT

  public:
    ScoreLabel(QWidget* parent=0,const char* name=0);
    void display( int n);
    void setPlayer( int n );
    void drawBuffer();
    void alphaDraw(int,int,QImage&);
    void backgroundChanged();
	void moveEvent(QMoveEvent*);
     

    QPixmap* buffer;
    QImage*  trans;

	

  protected:
    void paintEvent ( QPaintEvent*  );
    void resizeEvent( QResizeEvent* );

  private:
    int number;
    int player;
    QImage bg; 
};

#endif

