#include "kscoremanager.h"
#include "kscoreboarddialog.h"
#include "ksinglescoreboarddialog.h"

#include <KDE/KAboutData>
#include <KDE/KApplication>
#include <KDE/KCmdLineArgs>
#include <KDE/KDebug>
#include <KDE/KLocale>
#include <KDE/KLocalizedString>
#include <KDE/KRandom>
#include <KDE/KScoreDialog>
#include <KDE/KStandardDirs>

int main( int argc, char ** argv )
{
    KAboutData about( "kscoretest", "", ki18n("KScoreTest"), "0.0.1" );
    about.setShortDescription( ki18n("A simple app to test the new KDEGames highscore classes.") );
    about.setLicense( KAboutData::License_GPL_V2 );
    about.setCopyrightStatement( ki18n("© 2008, Parker Coates") );
    about.addAuthor( ki18n("Parker Coates"), ki18n("Developer"), "parker.coates@gmail.com" );

    KCmdLineArgs::init(argc, argv, &about);

    KApplication app;

    KGlobal::locale()->insertCatalog("libkdegames");

    kDebug() << "Running KScoreTest!";

    KScoreManager::self()->setScoreBoardLength(7);
    KScoreManager::self()->setOptions(KScoreManager::LowerScoresAreBetter | KScoreManager::AutomaticTimeStamp);

    KScoreManager::self()->addField(KScoreManager::Name);
    KScoreManager::self()->addCustomField(KScoreManager::Custom1, "Wiggles", i18n("Wiggles"));
    KScoreManager::self()->addCustomField(KScoreManager::Custom2, "SecretWiggles", i18n("Secret Wiggles"), false);
    KScoreManager::self()->addField(KScoreManager::Date);
    KScoreManager::self()->addField(KScoreManager::Score);

    KScoreManager::self()->addScoreGroupName("", i18n("Unnamed Group"));
    KScoreManager::self()->addScoreGroupName("Sniggles", i18n("Sniggles"));

    KScoreManager::ScoreEntry score;
    score[KScoreManager::Name] = KRandom::randomString(6 + KRandom::random() % 6);
    score[KScoreManager::Custom1] = KRandom::random() % 100;
    score[KScoreManager::Score] = KRandom::random() % 1000;

    //KSingleScoreBoardDialog dialog("Sniggles");
    KScoreBoardDialog dialog;
    dialog.setDisplayOptions(KScoreBoardDialog::HighlightLastScore);
    dialog.show();

    KScoreManager::self()->submitScore(score, "Sniggles");

    dialog.switchToGroup("");

    return app.exec();
}
