/****************************************************************
Copyright 2008  Parker Coates parker.coates@gmail.com

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************/

#ifndef KSINGLESCOREBOARDDIALOG_H
#define KSINGLESCOREBOARDDIALOG_H

#include <libkdegames_export.h>
#include <kscoreboardbase.h>

#include <KDialog>

/**
 * \class KScoreBoardDialog kscoreboarddialog.h <KScoreBoardDialog>
 *
 * \brief A KDialog based highscore table
 *
 * \since KDE 4.2
 * \author Matt Williams <matt@milliams.com>
 */
class KDEGAMES_EXPORT KSingleScoreBoardDialog : public KDialog, public KScoreBoardBase
{
    Q_OBJECT

    public:
        KSingleScoreBoardDialog(const QString& groupKey = QString());
        virtual ~KSingleScoreBoardDialog();

        void setGroup(const QString& groupKey);
        QString group() const;
        void setDisplayOptions(const KScoreBoardBase::DisplayOptions & options);

    public Q_SLOTS:
        void show();
        void exec();

    protected Q_SLOTS:
        virtual void accept();
        virtual void reject();

    private:
        class KSingleScoreBoardDialogPrivate;
        KSingleScoreBoardDialogPrivate* const d;

        Q_PRIVATE_SLOT(d, void newScore(const QString& groupKey, int rank))

        Q_DISABLE_COPY(KSingleScoreBoardDialog)
};

#endif
