/*
Copyright (c) 2006, 2007, Nicolas Roffet, <nicolas-kde@roffet.com>

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
*/



#include <kaboutdata.h>
#include <kapplication.h>
#include <kcmdlineargs.h>
#include <kexthighscore.h>
#include <khighscore.h>
#include <klocale.h>


#include "ksimilimainwindow.h"



int main(int argc, char *argv[])
{
	// TODO: find a better description
	KAboutData about("ksimili", 0, ki18n("KSimili"), "0.1.0", ki18n("A game like Set(R) for KDE"), KAboutData::License_GPL, ki18n("(c) 2006, 2007 Nicolas Roffet"));
	about.addAuthor (ki18n("Nicolas Roffet"), ki18n("Author & maintainer"), "nicolas-kde@roffet.com");
	KCmdLineArgs::init(argc, argv, &about);

	KHighscore::init("ksimili");

	KApplication app;

	//KExtHighscore::Manager *highscoresManager = new KExtHighscore::Manager(1,10);
	KExtHighscore::Manager manager;

	if (app.isSessionRestored())
		kRestoreMainWindows< KSimiliMainWindow >();
	else {
		KSimiliMainWindow *ksimiliMainWindow = new KSimiliMainWindow;
		ksimiliMainWindow->show();
	}

	return app.exec();
}
