/*
Copyright (c) 2006, 2007, Nicolas Roffet, <nicolas-kde@roffet.com>

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
*/

#include "ksimilideckofcards.h"



#include <QWidget>


#include "ksimiliboard.h"



KSimiliDeckOfCards::KSimiliDeckOfCards(QWidget *parent) : QObject(parent)
{
	m_random.setSeed(0);

	for (int i = 0; i<SUM_CARDS; ++i) {
		m_deckCards.append(i);
	}
}




int KSimiliDeckOfCards::takeNewCard()
{
	int newCardDeckIndex = rand() % m_deckCards.count();
	int newCardId = m_deckCards[newCardDeckIndex];
	
	m_deckCards.removeAll(newCardId);
	m_boardCards.append(newCardId);

	return newCardId;
}


void KSimiliDeckOfCards::removeCardFromBoard(const int cardId)
{
	m_boardCards.removeAll(cardId);
	m_deckCards.append(cardId);
}

#include "ksimilideckofcards.moc"
