/*
Copyright (c) 2006, 2007, Nicolas Roffet, <nicolas-kde@roffet.com>

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
*/

#ifndef KSIMILISTATSWIDGET_H
#define KSIMILISTATSWIDGET_H



#include <QWidget>


#include "ui_ksimilistatswidget.h"


/**
 * @brief Widget with many widgets on it to display some information (statistics) on the game.
 *
 * Following information is displayed on this widget:
 *    - Speed: number of found combinations per hour
 *    - Time left
 *    - Number of found ksimilis
 *    - Number of errors during the game
 */
class KSimiliStatsWidget : public QWidget, private Ui::KSimiliStatsWidget
{
	Q_OBJECT

	public:
		KSimiliStatsWidget(QWidget *parent = 0);
		int getCombinationsPerHour();

	public slots:
		void newGame(const int timeToPlay);
		void gameOver();
		void newCombinationFound();
		void newErrorFound();
		void timeLeftChanged(const int timeLeft);
		void displayPossibleCombinations(const int ksimilis);
		void activateDisplayPossibleCombinations(bool activation);

};


#endif //KSIMILISTATSWIDGET_H
