#include "ktankitem.h"
#include <KDebug>
#include <KGLPhysicsImpl2>
KTankItem::KTankItem(QString path)
  : KGLContainerItem()

{
carItem = new KGLSpriteItem(path+"car.png");
turretItem = new KGLSpriteItem(path+"canon.png");

addChild(carItem);
addChild(turretItem); 
carItem->setDirection(0,1);
turretItem->setDirection(0,1);
carItem->showDirection(true);
turretItem->showDirection(true);
//carItem->showBoundingBox(true);
showBoundingBox(true);
setDirection(0,1);
m_speedRotation = 0.05;
m_speed = 0.003;
m_turretAngle = 0;
moveBy(-carItem->transformCenter());
stop=false;

}
//==================================================
void KTankItem::setMouse(QPointF mouse)
{
m_turretAngle = -atan2(turretItem->transformCenter().x()-mouse.x(),turretItem->transformCenter().y()- mouse.y())  +M_PI;
turretItem->setAngle(m_turretAngle);


Eigen::Vector2d dir(0,1);
dir = Eigen::Rotation2D<double>(m_turretAngle) * dir;
turretItem->setDirection(dir.x(), dir.y());

//kDebug()<<transformPolygon();


}
//==================================================
void KTankItem::moveUp()
{





if ( transformPolygon().intersected(wall) != QPolygonF())
{

Eigen::Vector2d hori = Eigen::Vector2d(1.0,0.0);
Eigen::Vector2d verti = Eigen::Vector2d(0.0,1.0);

Eigen::Vector2d dir ( carItem->direction().x(), carItem->direction().y());
dir = dir.dot(hori) * hori;
setSpeed(m_speed);
setDirection(dir.x(), dir.y());
carItem->setDirection(dir.x(), dir.y());
stop = true;

}

else
{
setSpeed(m_speed);

stop= false;
}

}
//==================================================
void KTankItem::moveDown()
{

setSpeed(-m_speed);



}
//==================================================
void KTankItem::rotateLeft()
{

if ( stop == false)
{
carItem->rotate(m_speedRotation);
rotateDirection(m_speedRotation);
}

}
//==================================================
void KTankItem::rotateRight()
{

if ( stop == false)
{

carItem->rotate(-m_speedRotation);
rotateDirection(-m_speedRotation);
}

}
//==================================================
void KTankItem::rotateDirection(float a)
{
Eigen::Vector2d dir(direction().x(),direction().y());
dir = Eigen::Rotation2D<double>(a) * dir;
setDirection(dir.x(), dir.y());
carItem->setDirection(dir.x(), dir.y());
}
//==================================================
void KTankItem::collidingWith(KGLItemBase* item)
{
carItem->setColor(Qt::red);

wall=item->transformPolygon();
stop = true;








}