/* -*- coding: utf-8 -*- */

#ifndef KT_GROUNDITEM_H
#define KT_GROUNDITEM_H


#include <QPainter>
#include <QPointF>
#include <QPixmap>
#include <QGraphicsPixmapItem>
#include <QKeyEvent>
#include <QSize>
#include <QMap>
#include <QString>
#include <QDebug>
#include <QStyleOption>
/* This file is part of Ktank.
   Created by sacha schutz and olivier gueudelot

   KTank is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA
*/
class KTGroundSquare;

class KTGroundItem : public QGraphicsPixmapItem
{
public:
    KTGroundItem(QSize dim, const QPixmap & pixmap=QPixmap(), QGraphicsItem * parent=0);

    void setGround(QPoint position, int type);


private:
    QSize dimMap;
    QHash<QPoint , KTGroundSquare*> ground;


};


class KTGroundSquare
{
public:

    KTGroundSquare(QString n, QPoint p);

    void drawSuperimposedLayer();


private:

    QString name;
    QPoint position;
    int level;

}

#endif


