/***************************************************************************
 *   Copyright (C) 2003 by Albert Astals Cid                               *
 *   tsdgeos@terra.es                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef EVALUATIONRESULT_H
#define EVALUATIONRESULT_H

#include "kcase.h"

class evaluation
{
	public:
		evaluation();
		evaluation(evaluation *e);
		~evaluation();

		void setPlace(int p_x, int p_y);
		void setRemove(int r_x, int r_y);
		void setValue(int value);
		int getValue() const;
		bool possible() const;
		evaluation* bestScore(evaluation* e, kcase::PLAYER o);

		int p_x() const;
		int r_x() const;
		int p_y() const;
		int r_y() const;

	private:
		int score;
		int place_x;
		int place_y;
		int remove_x;
		int remove_y;
		bool isPossible;
};

class boardEvaluation
{
	public:
		boardEvaluation();
		~boardEvaluation();

		evaluation* getEvaluation(int i, int j);
		void setEvaluation(int i, int j, evaluation *e);
		int getValue(int i, int j) const;
		bool possible(int i, int j) const;
		evaluation* bestMove(kcase::PLAYER o);

	private:
		// a [3][3] where we'll store evaluations
		evaluation ***board;
};

#endif
