/***************************************************************************
 *   Copyright (C) 2003-2004 by Albert Astals Cid                          *
 *   tsdgeos@terra.es                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef KCASEWIDGET_H
#define KCASEWIDGET_H

#include <qframe.h>
#include <qevent.h>

#include "kcase.h"

class kcaseWidget : public QFrame, public kcase
{
Q_OBJECT
	public:
		kcaseWidget(QWidget *parent, int x, int y);

		// resets the case to not selected and not occupied
		void setEmpty();

		// sets o to ocupy the case
		void setOcupation(PLAYER o);

		// toggles the selection of the case
		void toggleSelected();

		// updates the colors of the case
		void updateColors();

	signals:
		// the user has clicked this case
		void caseClicked(int, int);

	protected:
		// returns the color of the background of the case
		QColor getBackgroundColor() const;

		// returns the color of the border of the piece
		QColor getBorderColor() const;

		// returns the color of the piece for the player that ocupies the case
		QColor getPlayerColor() const;

		// returns the shape of the piece for the player that ocupies the case
		int getShape() const;

		void mousePressEvent(QMouseEvent *e);
		void paintEvent(QPaintEvent *e);
};

#endif
