/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/


#ifndef DESCRIPTION_H_
#define DESCRIPTION_H_

#include <QByteArray>
#include <QString>
#include <QDomElement>

class Description {
public:
	static const QString ROOT_TAG;

	static const QString NAME_TAG;
	static const QString HINT_TAG;
	static const QString DESCRIPTION_TAG;

	static const QString VALUE_TAG;

	static const QString LOCALE_ATT;


	Description(){}
	~Description(){}

	static Description * read(const QByteArray & data);
	static Description * read(const QString & data);

	void setName(const QString & name);
	const QString name() const;

	void setDescription(const QString & description);
	const QString description() const;

	void setHint(const QString & hint);
	const QString hint() const;


private:
	static QString getValueOf(const QDomElement & el, const QString tag);
	static Description * read(const QDomDocument & document);

	/**The name*/
	QString m_name;

	/**A hint*/
	QString m_hint;

	/**A description*/
	QString m_description;

	QString m_state;

};

#endif /*DESCRIPTION_H_*/
