/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/


#ifndef PACKAGE_H_
#define PACKAGE_H_

#include <QList>
#include <QVariant>

#include "ds/data.h"

/**
 * This class provides a DAO for game packages.
 */
class Package
{
    public:
        Package();

        void insert(int i, Data * data);
        void append(Data * data);
        void removeAt(int i);
        void removeAll();

        int size();
        Data * at(int i);

        void setName(const QString & name);
        void setDescription(const QString & description);
        void setDefaultDescription(const QString & defaultDescription);
        void setFilename(const QString & name);

        QString name();
        QString description();
        QString filename();

    private:
        QList<Data *> * m_games;
        QString m_name;
        QString m_description;
        QString m_default_description;
        QString m_filename;
};
Q_DECLARE_METATYPE( Package * )

#endif /*PACKAGE_H_*/
