/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef COLORSELECTOR_H_
#define COLORSELECTOR_H_

#include "ds/data.h"
#include "colorbutton.h"

#include <QColor>
#include <QGridLayout>
#include <QRadioButton>
#include <QSet>
#include <QHash>

#ifndef KXMLGUIWINDOW_H
    #include <KXmlGuiWindow>
#endif

class ColorSelector : public QWidget
{
    Q_OBJECT

    public:
        ColorSelector(KXmlGuiWindow *parent);
        ~ColorSelector() { }

    public slots:
        void setData(Data * data);
        void nextColor();
        void selectColor(QColor * color);

    private:
        QGridLayout * m_layout;
        QList<ColorButton*> m_colorbuttons;
        QHash<QColor, ColorButton*> * m_colorMap;
};

#endif /*COLORSELECTOR_H_*/
