/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "./clevernessconfig.h"
#include <qgridlayout.h>
#include <kcombobox.h>
#include <klocalizedstring.h>
#include <qlabel.h>
#include <QCheckBox>
#include <ds/config.h>

#include <KComponentData>
#include <KConfig>
#include <KConfigGroup>
#include <KGlobal>
#include <KDebug>
#include <QSpinBox>

ClevernessConfig::ClevernessConfig() {
    QGridLayout *layout = new QGridLayout(this);

    layout -> addWidget(new QLabel(i18n("Autoselect color if only one is possible:"), this), 0, 0);
    QCheckBox *pb = new QCheckBox(this);
    pb->setObjectName("kcfg_"+Config::CONFIG_AUTOSELECT_CLICK_COLOR);
    layout -> addWidget(pb, 0, 1);

    layout -> addWidget(new QLabel(i18n("Wait ms before autoselecting:"), this), 1, 0);
    waitAutoselect = new QSpinBox(this);
    waitAutoselect->setMaximum(10000);
    waitAutoselect->setObjectName("kcfg_"+Config::CONFIG_WAIT_BEFORE_AUTOSELECT_CLICK_COLOR);
    layout -> addWidget(waitAutoselect, 1, 1);

    //TODO:
    connect(pb, SIGNAL(stateChanged(int)), this, SLOT(waitAutoselectChanged(int)));
}

void ClevernessConfig::waitAutoselectChanged(int checkstate) {
    kDebug() << "Disabling: " << ( Qt::Unchecked == checkstate );
    waitAutoselect->setDisabled(Qt::Unchecked == checkstate);
}

