/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/


#ifndef GRID_H
#define GRID_H

#include <qwidget.h>
#include "grid_center.h"
#include "grid_header.h"

#include "ds/data.h"

#include "colorselector.h"
#include "originalsize_picture.h"
#ifndef KXMLGUIWINDOW_H
    #include <kxmlguiwindow.h>
#endif
#include <KActionCollection>

class Grid : public QWidget {
Q_OBJECT

public:
	Grid(KXmlGuiWindow *parent);
	~Grid() {
	}

	Data * data();

public slots:
	void setData(Data * data);
    void readConfig();
    void findSolution();

signals:
    void dataSet(Data * data);
    void settingsChanged();

private:

    void connectGridParts(Abstract_Grid * source);
    void connectGridPartsToMoreSignals();

    ColorSelector * colors;

	GridCenter * central;
	GridHeader * column_header;
	GridHeader * line_header;

    OriginalSizePicture * picturePreview;

    void setupActions(KXmlGuiWindow *parent);


    QColor background;

};

#endif
