/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef NOG_OUT_H_
#define NOG_OUT_H_

#include <QString>

#include "ds/data.h"


/**
 * This class provides the means to store the information in a Data object.
 * The file format is a kind of XML.
 *
 * Row and Column information are a list of lists of (amount, color),
 * which can simply be given to Data::fromString which conveniently converts it.
 *
 * The other information of the file should be prett straight forward.
 * */
class NogOut
{
    public:

        static const QString GAME_TAG;

        static const QString NAME_TAG;
        static const QString HINT_TAG;
        static const QString DESCRIPTION_TAG;

        static const QString ROWS_TAG;
        static const QString COLUMNS_TAG;
        static const QString MATRIX_TAG;

        static QString createOutput(Data * data, bool saveMatrix=false);
		static void save(Data * data, const QString & outfile, bool saveMatrix=false);

};

#endif /*NOG_OUT_H_*/
