/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/


#ifndef NONOGRAM_IO_H
#define NONOGRAM_IO_H

#include <QString>
#include <QByteArray>

#include "ds/data.h"

/**
 * Interface for different fileformats to read and convert to internal data-format.
 */

class NonogramIo : public QObject
{

public:
    NonogramIo(QObject *parent=0):QObject(parent){};

	virtual Data * readFile(const QString & fileName ) = 0;
	virtual Data * readData(const QByteArray & data ) = 0;

};

#endif
