/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include <QString>
#include <QFile>

#include <KDebug>
#include <KCmdLineOptions>
#include <KCmdLineArgs>
#include <KIO/NetAccess>

#include "ds/data.h"

#include "io/nonogram_io.h"
#include "io/nog_out.h"
#include "io/io_factory.h"

int main(int argc, char *argv[])
{
    KCmdLineArgs::init( argc, argv, 0 );

    KCmdLineOptions options;
    options.add("+[files]", ki18n("Documents to open"));
    KCmdLineArgs::addCmdLineOptions(options);

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

    // Arguments (e.g. files to open)
    for (int i = 0; i < args->count(); i++) // Counting start at 0!
    {

        QString tmpFile;
        if (KIO::NetAccess::download(args->url(i), tmpFile, 0 )) {
            Data * data = Io_Factory::readFile(tmpFile);
			NogOut::save(data, tmpFile.replace(tmpFile.lastIndexOf(".")+1, tmpFile.size(), "nog"));

        }

    }

    return 0;
}

