/* objectimport.h

    Parsek - free client for playing 4X space strategy games
    Copyright (C) 2006-2007  Jure Repinc <jlp@holodeck1.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/** @file
* This a group of functions to convert objects from format used by
* libtpproto-cpp into format used by Parsek.
* @author Jure Repinc <jlp@holodeck1.com>
*/

#ifndef OBJECTIMPORT_H
#define OBJECTIMPORT_H

#include <tpproto/object.h>
#include "objectitem.h"

using namespace TPProto;

void importObject(boost::shared_ptr<Object> source, ObjectItem *target);
void setCommonProperties(boost::shared_ptr<Object> source, ObjectItem *target);


#endif // OBJECTIMPORT_H
