#ifndef PARSEKEVENTLOOP_H
#define PARSEKEVENTLOOP_H

/*  Parsek Event Loop
 *
 *  Copyright (C) 2009  The Thousand Parsec Project
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <QObject>
#include <QTimer>
#include <QHash>
#include <QSocketNotifier>
#include <tpproto/eventloop.h>
#include <tpproto/tpsocket.h>
#include <boost/throw_exception.hpp>

class ParsekEventLoop : public QObject, public TPProto::EventLoop
{
Q_OBJECT

public:
    ParsekEventLoop();
    virtual ~ParsekEventLoop();
    virtual void listenForSocketRead(TPProto::TPSocket *sock);
    virtual void listenForSocketWrite(TPProto::TPSocket *sock);
    virtual TPProto::TimerConnection setTimer(uint32_t interval, const TPProto::TimerSignal::slot_type &callback);
public Q_SLOTS:
    void activated_read(int fd);
    void activated_write(int fd);
    void timeout();
private:
    //TIMERS AND CALLBACK STUFF
    QHash<QTimer*,TPProto::TimerSignal*> timers;

    //SOCKET STUFF
    struct ParsekSocket //covert to dedicated class later??
    {
        ParsekSocket() : socket(0), notifier(0) {}
        ParsekSocket(TPProto::TPSocket *socket, QSocketNotifier *notifier) : socket(socket), notifier(notifier) {}
        TPProto::TPSocket *socket;
        QSocketNotifier *notifier;
    };
    QHash<int,ParsekSocket> readset;
    QHash<int,ParsekSocket> writeset;

};
#endif
