/*
    Copyright 2008 Gábor Lehel <illissius@gmail.com>

    This file is part of Superpong.

    Superpong is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Superpong is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Superpong (files COPYING and COPYING.LESSER).
    If not, see <http://www.gnu.org/licenses/>.
*/

#include <KAboutData>
#include <KCmdLineArgs>
#include "pongapplication.h"

int main( int argc, char *argv[] )
{
    KAboutData aboutData( // The program name used internally.
                          "superpong",
                          // The message catalog name
                          // If null, program name is used instead.
                          0,
                          // A displayable program name string.
                          ki18n("So-Called \"Super\" Pong"),
                          // The program version string.
                          "0.0",
                          // Short description of what the app does.
                          ki18n("SUPERPONG!"),
                          // The license this code is released under
                          KAboutData::License_BSD,
                          // Copyright Statement
                          ki18n("(c) 2008 Gábor Lehel"),
                          // Optional text shown in the About box.
                          // Can contain any information desired.
                          ki18n("This is an About box!"),
                          // The program homepage string.
                          "http://google.com/",
                          // The bug report email address
                          "submit@bugs.kde.org" );

    KCmdLineArgs::init( argc, argv, &aboutData );
    PongApplication().exec();
}
