/*
    Copyright 2008 Gábor Lehel <illissius@gmail.com>

    This file is part of Superpong.

    Superpong is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Superpong is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Superpong (files COPYING and COPYING.LESSER).
    If not, see <http://www.gnu.org/licenses/>.
*/


#include "pongview.h"

#include <QResizeEvent>

PongView::PongView( QGraphicsScene *s, QWidget *p )
    : super( s, p ), m_scale( 1.0 )
{
}

QSize PongView::sizeHint() const
{
     return QSize( int( sceneRect().width() ) + frameWidth() * 2, int( sceneRect().height() ) + frameWidth() * 2 );
}

void PongView::resizeEvent( QResizeEvent *e )
{
    const qreal saspect = sceneRect().width() / sceneRect().height();
    const qreal waspect = qreal( e->size().width() ) / e->size().height();
    qreal factor = 42;
    if( saspect > waspect ) factor = qreal( e->size().width() ) / ( m_scale * sceneRect().width() );
    else factor = qreal( e->size().height() ) / ( m_scale * sceneRect().height() );
    //qDebug() << e->size() << e->oldSize() << sceneRect() << scene()->sceneRect() << m_scale << saspect << waspect << factor;
    scale( factor, factor );
    m_scale *= factor;
    e->accept();
}
