#ifndef WORDKUBES_H
#define WORDKUBES_H
 
#include <KMainWindow>
#include <KTextEdit>
#include <QGridLayout>
#include <QStringList>
#include <QSvgRenderer>
#include <sonnet/speller.h>
#include <QActionGroup>
#include <QTimer>


#include "tile.h"
#include "ui_wordkubes.h"
 
class WordKubes : public KMainWindow
{
  Q_OBJECT
  public:
	WordKubes(QWidget *parent=0);
	~WordKubes();
	virtual void setupActions();

  public slots:
	virtual void submitPressed();
	virtual bool checkOnBoard(QString);
	virtual void appendChar(QChar);

	virtual void startGame();
	virtual void endGame();
	virtual void updateClock();


  private:
	Ui::MainWindow ui;
	QGridLayout	board;
	QTimer		gameTimer;
	int 		gameClock;
	bool		gameActive;
	QList<Tile *>	tiles;
	QStringList diceList;
	bool checkOnBoard(QList<Tile *>,QString);
	int totalScore;
	Sonnet::Speller* speller;
	QStringList		 wordsPlayed;
	QActionGroup*	 actionCollection;

	virtual void	setupBoard();
	virtual void 	populateBoard();
	virtual void 	populateNeighbours();
	virtual int	 	getScore(QString);
	virtual void	updateScore();
	virtual void 	clearHighlight();
	virtual void 	loadDice();
	virtual QChar	getDiceLetter();

};
 
#endif
